% This script compute asymptotic variances used in computing the error bands of impulse responses in 
% "Exiting from QE" by Fumio Hayashi and Junko Koeda (Quantitative Economics forthcoming)

clear

options = optimset('Display','iter','Diagnostics','on');
options  = optimset(options, 'TolFun',1e-3);
options  = optimset(options, 'TolX',1e-3);

%% Theta A
% Subsample s=P 
load ../estimates/LA_est.mat
load ../data/subsamples/Lagged_subsampleP_199503

X0=[c2_P(1) Phi2_P(1,:) c2_P(2) Phi2_P(2,:) S2_P(1,1) S2_P(2,:)];
[X,likelihood,exitflag,output,grad,hessian]=fminunc('Lfunc_LA_P',X0,options);
exitflag
output
ThetahatA_P=X;
T_P=length(yr_month);
AvarA_P=inv(hessian/T_P);
std_errorA_P=diag(sqrt(inv(hessian)));
LvalueA_P=likelihood;
c2_P=[X(1);X(6)];Phi2_P=[X(2:5);X(7:10)];
S2_P=[X(11) 0;X(12:13)];

% Subsample s=Z
load ../data/subsamples/Lagged_subsampleZ yr_month
X0=[c2_Z(1) Phi2_Z(1,:) c2_Z(2) Phi2_Z(2,:) S2_Z(1,1) S2_Z(2,:)];
[X,likelihood,exitflag,output,grad,hessian]=fminunc('Lfunc_LA_Z',X0,options);
exitflag
output
ThetahatA_Z=X;
T_Z=length(yr_month);
AvarA_Z=inv(hessian/T_Z);
std_errorA_Z=diag(sqrt(inv(hessian)));
LvalueA_Z=likelihood;
c2_Z=[X(1);X(7)];Phi2_Z=[X(2:6);X(8:12)] ;
S2_Z=[X(13) 0;X(14:15)];

save  AvarA_est AvarA_P AvarA_Z ThetahatA_P ThetahatA_Z  LvalueA_P LvalueA_Z 

%% Theta C
load ../estimates/LC_est.mat alpha_ms beta_ms sig_ms
X0=[alpha_ms beta_ms sig_ms];
[X,fval,exitflag,output,grad,hessian]=fminunc('Lfunc_LC',X0,options);
exitflag
output
ThetahatC=X;
T_C=length(yr_month);
AvarC=inv(hessian/T_C);
std_errorC=diag(sqrt(inv(hessian)));

save  AvarC_est AvarC T_C ThetahatC 

