% This script creates subsamples used in estimation in
% "Exiting from QE" by Fumio Hayashi and Junko Koeda (Quantitative Economics forthcoming)
%  input data: "198801_201212.mat"
%  output file: "199201_201212.mat", "199201_201212.mat",
%  "Lagged_subsampleP_199503.mat", "Lagged_subsampleP_199305.mat",
%  "Lagged_subsampleZ.mat","Lagged_subsampleW.mat","Subsample_demand.mat"
%  August 2018

% The subsample of 199201-201212
clear 
load ../../data/subsamples/198801_201212.mat yr_month p p12 cao_x r rbar m  p12lag plag cao_xlag rlag rbarlag slag qelag mlag trend s qe hp_x hp_xlag hp_trend 
T=find(yr_month==199201);
yr_month=yr_month(T:end); p=p(T:end);p12=p12(T:end);cao_x=cao_x(T:end);r=r(T:end);rbar=rbar(T:end); m=m(T:end);s=s(T:end);  qe=qe(T:end);
p12lag=p12lag(T:end); plag=plag(T:end); cao_xlag=cao_xlag(T:end);rlag=rlag(T:end); rbarlag=rbarlag(T:end);mlag=mlag(T:end);slag=slag(T:end); qelag=qelag(T:end); 
trend=trend(T:end);hp_x=hp_x(T:end);hp_trend=hp_trend(T:end);
save ../../data/subsamples/199201_201212  yr_month p12 cao_x r rbar m s p12lag  cao_xlag rlag mlag slag trend qe hp_x hp_xlag hp_trend 

% The lagged subsample P from 199503
clear 
load ../../data/subsamples/198801_201212.mat yr_month p p12 cao_x r rbar m  p12lag plag cao_xlag rlag rbarlag slag qelag mlag trend s qe hp_x hp_xlag hp_trend 
T=find(yr_month==199503);
yr_month=yr_month(T:end); r=r(T:end);m=m(T:end);p=p(T:end);p12(T:end);cao_x=cao_x(T:end);rbar=rbar(T:end); s=s(T:end); 
p12lag=p12lag(T:end); plag=plag(T:end); rlag=rlag(T:end); rbarlag=rbarlag(T:end); slag=slag(T:end); qelag=qelag(T:end);
mlag=mlag(T:end); cao_xlag=cao_xlag(T:end);trend=trend(T:end); qe=qe(T:end);hp_x=hp_x(T:end);hp_xlag=hp_xlag(T:end);hp_trend=hp_trend(T:end); 
yr_month= yr_month(slag==1);
rlag    = rlag(slag==1);
plag    = plag(slag==1);
mlag    = mlag(slag==1);
p12lag   = p12lag(slag==1);
cao_xlag  = cao_xlag(slag==1);
hp_xlag  = hp_xlag(slag==1);
r       = r(slag==1);
p       = p(slag==1);
rbar    = rbar(slag==1);
qe      = qe(slag==1);
m       = m(slag==1);
p12      = p12(slag==1);
cao_x     = cao_x(slag==1);
hp_x     = hp_x(slag==1);
trend   = trend(slag==1);
hp_trend   = hp_trend(slag==1);
s       = s(slag==1);
md=m;mdlag=mlag;qelag=qelag(slag==1);mdlag(qelag>1)=0;
save ../../data/subsamples/Lagged_subsampleP_199503  yr_month p cao_x r m plag rlag mlag cao_xlag   trend   hp_x hp_xlag hp_trend md mdlag

% The lagged subsample P from 199305
clear 
load ../../data/subsamples/198801_201212.mat yr_month p p12 cao_x r rbar m  p12lag plag cao_xlag rlag rbarlag slag qelag mlag trend s qe  hp_x hp_xlag hp_trend 
T=find(yr_month==199305);
yr_month=yr_month(T:end); r=r(T:end);m=m(T:end);p=p(T:end);p12(T:end);cao_x=cao_x(T:end);rbar=rbar(T:end); s=s(T:end); 
p12lag=p12lag(T:end); plag=plag(T:end); rlag=rlag(T:end); rbarlag=rbarlag(T:end); slag=slag(T:end); qelag=qelag(T:end);
mlag=mlag(T:end); cao_xlag=cao_xlag(T:end);trend=trend(T:end); qe=qe(T:end);hp_x=hp_x(T:end);hp_xlag=hp_xlag(T:end);hp_trend=hp_trend(T:end); 
yr_month= yr_month(slag==1);
rlag    = rlag(slag==1);
plag    = plag(slag==1);
mlag    = mlag(slag==1);
p12lag   = p12lag(slag==1);
cao_xlag  = cao_xlag(slag==1);
hp_xlag  = hp_xlag(slag==1);
r       = r(slag==1);
p       = p(slag==1);
rbar    = rbar(slag==1);
qe      = qe(slag==1);
m       = m(slag==1);
p12      = p12(slag==1);
cao_x    = cao_x(slag==1);
hp_x     = hp_x(slag==1);
trend   = trend(slag==1);
hp_trend   = hp_trend(slag==1);
s       = s(slag==1);
save ../../data/subsamples/Lagged_subsampleP_199305  yr_month p cao_x r m plag rlag mlag cao_xlag   trend  hp_x hp_xlag hp_trend  

% The lagged subsample Z
clear 
load ../../data/subsamples/198801_201212.mat yr_month p p12 cao_x r rbar m  p12lag plag cao_xlag rlag rbarlag slag qelag mlag trend s qe  hp_x hp_xlag hp_trend 
yr_month= yr_month(qelag>1);
rlag    = rlag(qelag>1);
plag    = plag(qelag>1);
mlag    = mlag(qelag>1);
p12lag  = p12lag(qelag>1);
cao_xlag  = cao_xlag(qelag>1);
hp_xlag  = hp_xlag(qelag>1);
r       = r(qelag>1);
p       = p(qelag>1);
rbar    = rbar(qelag>1);
qe      = qe(qelag>1);
m       = m(qelag>1);
p12     = p12(qelag>1);
cao_x   = cao_x(qelag>1);
hp_x    = hp_x(qelag>1);
trend   = trend(qelag>1);
hp_trend   = hp_trend(qelag>1);
s       = s(qelag>1);
save ../../data/subsamples/Lagged_subsampleZ  yr_month p cao_x r m plag rlag mlag cao_xlag qelag  trend  hp_x hp_xlag hp_trend 

% The lagged subsample W
clear 
load ../../data/subsamples/198801_201212.mat yr_month p p12 cao_x r rbar m  p12lag plag cao_xlag rlag rbarlag slag qelag mlag trend s qe  hp_x hp_xlag hp_trend 
yr_month= yr_month(qelag==1);
rlag    = rlag(qelag==1);
plag    = plag(qelag==1);
mdlag    = mlag(qelag==1);
p12lag  = p12lag(qelag==1);
cao_xlag  = cao_xlag(qelag==1);
hp_xlag  = hp_xlag(qelag==1);
r       = r(qelag==1);
p       = p(qelag==1);
rbar    = rbar(qelag==1);
qe      = qe(qelag==1);
md       = m(qelag==1);
p12     = p12(qelag==1);
cao_x   = cao_x(qelag==1);
hp_x    = hp_x(qelag==1);
trend   = trend(qelag==1);
hp_trend   = hp_trend(qelag==1);
s       = s(qelag==1);
save ../../data/subsamples/Lagged_subsampleW  yr_month p cao_x r md plag rlag mdlag cao_xlag qelag  trend  hp_x hp_xlag hp_trend 

% The subsample with active demand for excess reserves
clear 
load ../../data/subsamples/198801_201212.mat yr_month p p12 cao_x r rbar  p12lag plag cao_xlag rlag rbarlag slag qelag trend s qe   m mlag
yr_month= yr_month(qe<=1);
rlag    = rlag(qe<=1);
plag    = plag(qe<=1);
mdlag   = mlag(qe<=1);qelag=qelag(qe<=1);mdlag(qelag>1)=0;
p12lag  = p12lag(qe<=1);
cao_xlag  = cao_xlag(qe<=1);
r       = r(qe<=1);
p       = p(qe<=1);
rbar    = rbar(qe<=1);
md      = m(qe<=1);
p12     = p12(qe<=1);
cao_x   = cao_x(qe<=1);
trend   = trend(qe<=1);
s       = s(qe<=1);
save ../../data/subsamples/Subsample_demand  yr_month p p12 rbar cao_x r  plag rlag  cao_xlag qelag  trend  md mdlag
