% Function merge.m
%
%  Merges two matrixes Z1 and Z2
%  Assumes for each matrix (Z1 and Z2) rows are sorted by the first
%  column, whose elements are integers.
%  The first column of Z (combined matrix) is the integers from Z1 and
%  Z2.  The second column is 1 if the row is from Z1.
%  The third column is 1 if the row is from Z2.
%  That's followed by columns of Z1 (other than the first) and then 
%  by columns of Z2 (other than the first column).
%

function Z=merge(Z1,Z2)

nrows1=size(Z1,1);
ncols1=size(Z1,2);
nrows2=size(Z2,1);
ncols2=size(Z2,2);

n1=min(Z1(1,1),Z2(1,1));
n2=max(Z1(nrows1,1),Z2(nrows2,1));
x=n1;
for i=n1+1:n2
    if sum(Z1(:,1)==i)>0 | sum(Z2(:,1)==i)>0;x=cat(1,x,i);end
end        

Z=cat(2,zeros(numel(x),2),zeros(numel(x),ncols1+ncols2-2)*NaN);

for i=1:nrows1
    j=find(x==Z1(i,1));
    Z(j,1)=1;
    if ncols1>=1;Z(j,3:ncols1+1)=Z1(i,2:ncols1);end
end

for i=1:nrows2
    j=find(x==Z2(i,1));
    Z(j,2)=1;
    if ncols2>=1;Z(j,ncols1+2:ncols1+ncols2)=Z2(i,2:ncols2);end
end

Z=cat(2,x,Z);
