% This script computes the threshold m shown in Figure 5 in
% "Exiting from QE" by Fumio Hayashi and Junko Koeda (Quantitative Economics forthcoming)
clear 

load ../data/subsamples/198801_201212.mat 
load ../estimates/LA_est
load ../estimates/LB_est
load ../estimates/LC_est

Y        = [p cao_x r m ];
horizon  = 60;


t0=find(yr_month==200103);
t_end=find(yr_month==200606);
for t=t0:t_end
    computing_threshold_in=yr_month(t)
    m0_init=0;
    threshold=1;   
    trend=[trend(1:t); ones(200,1)*trend(t)];
    rbar=[rbar(1:t);ones(200,1)*rbar(t)];

    
    while threshold>0
        m0_init=m0_init+0.01;
        for iter =1:1000
        s0_b= 0;
        r0_b = r(t);
        m0_b = m0_init; 
        plag0_vec_b=p(t-11:t) ;
        plag0_vec_a=plag0_vec_b;
        s0_a=1;
        r0_a= r(t);
        m0_a = 0; 
        Y0_b =[Y(t,1:2) r0_b m0_b]';
        Y0_a =[Y(t,1:2) r0_a m0_a]';
        Y0_b_init=Y0_b;   
        Y0_a_init=Y0_a;   
            
        [temp_a2,temp_b2,temp_a,temp_b ] =Func_IR(Y,trend,rbar,yr_month,...
                t,horizon,S2_P,S2_Z,c2_P,c2_Z,Phi2_P,Phi2_Z,...
                alpha_r,trendcoeff,beta_r,gamma_r,sig_r,pibar,sig_pibar,...
                alpha_ms,beta_ms,sig_ms,Y0_b, Y0_a, s0_b, s0_a, plag0_vec_a, plag0_vec_b);             
            
        xmat_temp_a(iter,:) =[Y0_a_init(2) temp_a(2,:)];
        xmat_temp_b(iter,:) =[Y0_b_init(2) temp_b(2,:)];
        clear temp_a temp_b
    end
    temp2_a=mean(xmat_temp_a,1);
    temp2_b=mean(xmat_temp_b,1);
    clear xmat_temp_a xmat_temp_b
    x_a=temp2_a;
    x_b=temp2_b;
    threshold=sum(x_a-x_b);
    end
    threshold_t(t-t0+1,:)=[m0_init ];
end

% write to Excel file
header={'yr_month'  'm_act' 'm0'  };
z=[yr_month(t0:t_end) m(t0:t_end) threshold_t];
xlswrite('threshold',NaN(size(z,1)+5,size(z,2)+5),'Sheet1','a1');
xlswrite('threshold',header,'Sheet1','a1');
xlswrite('threshold',z,'Sheet1','a2');
