function [temp_a2,temp_b2,temp_a,temp_b ] =Func_IR_demand(Y,trend,rbar,yr_month,...
    t,horizon,S2_P,S2_Z,c2_P,c2_Z,Phi2_P,Phi2_Z,...
    alpha_r,trendcoeff,beta_r,gamma_r,sig_r,pibar,sig_pibar,...
    alpha_md,beta_md,gamma_md,sig_md,alpha_ms,beta_ms,sig_ms,Y0_b, Y0_a, s0_b, s0_a, plag0_vec_a, plag0_vec_b)

for k=1:horizon 
    shock=randn(6,1); %  u2, vr, vpibar, vm
    %% scenario a
    if s0_a==1            
        temp_y2_a = c2_P + Phi2_P*[trend(t+k);Y0_a] + S2_P*shock(1:2);
        plag1_vec_a = [plag0_vec_a(2:end);temp_y2_a(1)];
        temp_cpi_a= sum(plag1_vec_a)/12;
        temp_taylor_a  = alpha_r  + [beta_r' gamma_r]*[temp_cpi_a; temp_y2_a(2) ; Y0_a(3)]  + trendcoeff*trend(t+k)+ sig_r*shock(3);
        %% setting s1 given s0=1
        if temp_taylor_a >rbar(t+k)
            s1_a=1;
            temp_r_a= temp_taylor_a;
            temp_m_a = max(0,alpha_md +beta_md*[temp_cpi_a temp_y2_a(2) temp_taylor_a-rbar(t+k)]' +gamma_md*Y0_a(end)+ sig_md*shock(5)); 
        else
            s1_a=0;
            temp_r_a = rbar(t+k);
            temp_m_a = max(0,alpha_ms +beta_ms*[temp_cpi_a temp_y2_a(2) Y0_a(end)]'+ sig_ms*shock(6));
        end
    else % s0_a==0
        temp_y2_a = c2_Z + Phi2_Z*[trend(t+k);Y0_a] + S2_Z*shock(1:2);
        plag1_vec_a = [plag0_vec_a(2:end);temp_y2_a(1)];
        temp_cpi_a=sum(plag1_vec_a)/12;
        temp_taylor_a  = alpha_r  + [beta_r' gamma_r]*[temp_cpi_a; temp_y2_a(2) ; Y0_a(3)]   + trendcoeff*trend(t+k)+ sig_r*shock(3);
        %% setting s1 given s0=0
        if temp_taylor_a >rbar(t+k) & temp_cpi_a > pibar+sig_pibar*shock(4);
            s1_a=1;
            temp_r_a= temp_taylor_a;
            temp_m_a =  0; % m is assumed to drop when the regime shift from Z to P
        else
            s1_a=0;
            temp_r_a = rbar(t+k);
            temp_m_a = max(0,alpha_ms +beta_ms*[temp_cpi_a temp_y2_a(2) Y0_a(end)]'+ sig_ms*shock(6));
        end
    end
    %% scenario b
    if s0_b==1
        temp_y2_b = c2_P + Phi2_P*[trend(t+k);Y0_b]+ S2_P*shock(1:2);
        plag1_vec_b = [plag0_vec_b(2:end);temp_y2_b(1)];
        temp_cpi_b= sum(plag1_vec_b)/12;
        temp_taylor_b  = alpha_r  + [beta_r' gamma_r]*[temp_cpi_b; temp_y2_b(2) ; Y0_b(3)]  + trendcoeff*trend(t+k) + sig_r*shock(3);
        %% setting s1 given s0=1
        if temp_taylor_b >rbar(t+k)
            s1_b=1;
            temp_r_b= temp_taylor_b;
            temp_m_b =  max(0,alpha_md +beta_md*[temp_cpi_b temp_y2_b(2) temp_taylor_b-rbar(t+k)]' +gamma_md*Y0_b(end)+ sig_md*shock(5)); 
        else
            s1_b=0;
            temp_r_b = rbar(t+k);
            temp_m_b = max(0,alpha_ms +beta_ms*[temp_cpi_b temp_y2_b(2) Y0_b(end) ]'+ sig_ms*shock(6)); 
        end
    else % s0_b==0
        temp_y2_b = c2_Z + Phi2_Z*[trend(t+k);Y0_b]+ S2_Z*shock(1:2);
        plag1_vec_b = [plag0_vec_b(2:end);temp_y2_b(1)];
        temp_cpi_b=sum(plag1_vec_b)/12;
        temp_taylor_b  = alpha_r  + [beta_r' gamma_r]*[temp_cpi_b; temp_y2_b(2) ; Y0_b(3)]   + trendcoeff*trend(t+k) + sig_r*shock(3);
        %% setting s1 given s0=0
        if temp_taylor_b >rbar(t+k)  & temp_cpi_b > pibar+sig_pibar*shock(4);
            s1_b=1;
            temp_r_b= temp_taylor_b;
            temp_m_b = 0; 
        else
            s1_b=0;
            temp_r_b = rbar(t+k);
            temp_m_b = max(0,alpha_ms +beta_ms*[temp_cpi_b temp_y2_b(2) Y0_b(end) ]'+ sig_ms*shock(6));
        end
    end
    Y1_a=[temp_y2_a;temp_r_a;temp_m_a];
    Y1_b=[temp_y2_b;temp_r_b;temp_m_b];
    temp_a(:,k)=Y1_a;
    temp_b(:,k)=Y1_b;
    temp_a2(k)=s1_a;
    temp_b2(k)=s1_b;
    plag0_vec_a=plag1_vec_a;
    plag0_vec_b=plag1_vec_b;
    plag_temp_a(:,k) = plag1_vec_a;
    plag_temp_b(:,k) = plag1_vec_b;
    Y0_a=Y1_a;
    Y0_b=Y1_b;
    s0_a=s1_a;
    s0_b=s1_b;
end
