
function likelihood = Lfunc_LB(theta)
load ../data/subsamples/Subsample_demand yr_month r rbar md p12 cao_x  mdlag 

% mapping of X to parameters
alpha_md     = theta(1);
beta_md      = theta(2:4)';
gamma_md     = theta(5); %gamma=1-rho
inv_sig_md   = theta(6);

% transformed data
me      = ones(length(r),1)*alpha_md+[p12 cao_x (r-rbar)]*beta_md+mdlag*gamma_md;
resid_m = md-me;
diff    = me-0.005;  % setting the limit observation as the months for which m<0.5%
Fm      = normcdf(diff*inv_sig_md); 
g1      = normpdf(resid_m,0,1/inv_sig_md); % 

T=length(me);
temp0=0;
for t=1:T
    if md(t)>=0.005 
        temp1=temp0+log(g1(t));
    else
        temp1=temp0+log(1-Fm(t));
    end
    temp0=temp1;
end

LB=temp0;
likelihood=-LB;