% This script compute asymptotic variances used in computing the error bands of impulse responses in 
% "Exiting from QE" by Fumio Hayashi and Junko Koeda (Quantitative Economics forthcoming)

clear

options = optimset('Display','iter','Diagnostics','on');
options  = optimset(options, 'TolFun',1e-3);
options  = optimset(options, 'TolX',1e-3);

%% Theta A
% Subsample s=P 
load LA_est_demand 
load ../data/subsamples/Lagged_subsampleP_199503 yr_month

X0=[c2_P(1) Phi2_P(1,:) c2_P(2) Phi2_P(2,:) S2_P(1,1) S2_P(2,:)];
[X,likelihood,exitflag,output,grad,hessian]=fminunc('Lfunc_LA_P_demand',X0,options);
exitflag
output
ThetahatA_P=X;
T_P=length(yr_month);
AvarA_P=inv(hessian/T_P);
std_errorA_P=diag(sqrt(inv(hessian)));
LvalueA_P=likelihood;
c2_P=[X(1);X(6)];Phi2_P=[X(2:5);X(7:10)];
S2_P=[X(11) 0;X(12:13)];

% The system, s=QE2 or 3
load ../data/subsamples/Lagged_subsampleW yr_month
X0=[c2_W(1) Phi2_W(1,:) c2_W(2) Phi2_W(2,:) S2_W(1,1) S2_W(2,:)];
[X,likelihood,exitflag,output,grad,hessian]=fminunc('Lfunc_LA_W',X0,options);
exitflag
output
ThetahatA_W=X;
T_W=length(yr_month);
AvarA_W=inv(hessian/T_W);
std_errorA_W=diag(sqrt(inv(hessian)));
LvalueA_W=likelihood;
c2_W=[X(1);X(5)];Phi2_W=[X(2:4);X(6:8)]; 
S2_W=[X(9) 0;X(10:11)];
save  AvarA_est_demand AvarA_P AvarA_W ThetahatA_P ThetahatA_W  LvalueA_P LvalueA_W

load LC_est_demand alpha_md beta_md sig_md gamma_md
X0=[alpha_md beta_md gamma_md 1/sig_md];
[X,fval,exitflag,output,grad,hessian]=fminunc('Lfunc_LC_demand',X0,options);
exitflag
output
ThetahatC=X;
T_C=length(yr_month);
AvarC=inv(hessian/T_C);
std_errorC=diag(sqrt(inv(hessian)));
save  AvarC_est_demand AvarC T_C ThetahatC

